-------------------------------------------------------------------------
SET timing off
-- creating performance test view

CREATE OR REPLACE FUNCTION view_filter (
  p_owner  IN  VARCHAR2)
  RETURN VARCHAR2
AS
BEGIN
  RETURN p_owner;
END;
/

-------------------------------------------------------------------------
DROP TABLE big_tab;
SET timing off
CREATE TABLE big_tab AS
-- increase table size
SELECT * FROM all_objects;

BEGIN
  FOR i IN 1 .. 5
  LOOP
    INSERT INTO big_tab
      (SELECT *
         FROM big_tab);
    COMMIT;
  END LOOP;
END;
/

ANALYZE TABLE big_tab COMPUTE STATISTICS;

-------------------------------------------------------------------------
SET timing off
-- Create view calling user-defined PL/SQL function
CREATE OR REPLACE VIEW big_ud_view
AS
  SELECT owner, view_filter (owner) function_owner
    FROM big_tab;

-- Create view calling a built-in PL/SQL function
CREATE OR REPLACE VIEW big_bi_view
AS
  SELECT owner,
         DECODE (owner, owner, owner) function_owner
    FROM big_tab;

SET timing on
-- time the query on the base table
SELECT COUNT (owner) FROM big_tab;
-- run again to ensure caching does not affect the reults

-- time the query on the view
SELECT COUNT (function_owner) FROM big_ud_view;

-- time the query on the view
SELECT COUNT (function_owner) FROM big_bi_view;
