-- grant unlimited tablespace to sec_mgr;

DROP TABLE big_tab;
SET timing off
CREATE TABLE big_tab AS
SELECT * FROM all_objects;

BEGIN
  FOR i IN 1 .. 5
  LOOP
    INSERT INTO sec_mgr.big_tab
      (SELECT *
         FROM sec_mgr.big_tab);
    COMMIT;
  END LOOP;
END;
/

-------------------------------------------------------------------------
-- Create the row security function.
-- This function will be called by the view.
CREATE OR REPLACE FUNCTION view_filter (
  p_owner  IN  VARCHAR2)
  RETURN NUMBER
AS
BEGIN
  IF (   p_owner = USER
      OR SYS_CONTEXT ('userenv', 'isdba') = 'TRUE')
  THEN
    RETURN 1;
  ELSE
    RETURN 0;
  END IF;
END;
/
-- Creating view over table with function to filter rows
CREATE OR REPLACE VIEW big_view
AS
  SELECT *
    FROM big_tab
   WHERE 1 = view_filter (owner);

SET timing on
SELECT COUNT (*)
  FROM big_tab
 WHERE 1 = DECODE (owner, USER, 1, 0)
    OR SYS_CONTEXT ('userenv', 'isdba') = 'TRUE';

SELECT COUNT(*) FROM big_view;


CREATE OR REPLACE VIEW big_view2
AS
  SELECT * FROM big_tab
   WHERE 1 = DECODE (owner, USER, 1, 0)
      OR SYS_CONTEXT ('userenv', 'isdba') = 'TRUE';

SET timing on
SELECT COUNT (*)
  FROM big_tab
 WHERE 1 = DECODE (owner, USER, 1, 0)
    OR SYS_CONTEXT ('userenv', 'isdba') = 'TRUE';

SELECT COUNT (*)
  FROM big_view;
SELECT COUNT (*) FROM big_view2;

------------------------------------------------
-- creating VPD function
-- allow owner of table to see all records, otherwise, users see their own objects

CREATE OR REPLACE FUNCTION owner_admin (
  p_schema  IN  VARCHAR2 DEFAULT NULL,
  p_object  IN  VARCHAR2 DEFAULT NULL)
  RETURN VARCHAR2
AS
BEGIN
  IF (SYS_CONTEXT ('userenv', 'isdba') = 'TRUE')
  THEN
    RETURN NULL;              -- returns all rows
  ELSE
    RETURN 'OWNER = USER';
  END IF;
END;
/

CREATE OR REPLACE VIEW big_vpd_view
AS
  SELECT *
    FROM big_tab;

BEGIN
  DBMS_RLS.add_policy
             (object_name        => 'BIG_VPD_VIEW',
              policy_name        => 'BIG_VPD_VIEW_SIUD',
              policy_function    => 'owner_admin');
END;
/

SET timing on
SELECT COUNT (*)
  FROM big_tab
 WHERE 1 = DECODE (owner, USER, 1, 0)
    OR SYS_CONTEXT ('userenv', 'isdba') = 'TRUE';
SELECT COUNT (*)
  FROM big_view;
SELECT COUNT (*)
  FROM big_vpd_view;
