------------------ Views for RLS --------------
--DROP TABLE people$;

--CREATE TABLE people$ AS SELECT * FROM emp;

CONN scott/tiger

CREATE OR REPLACE VIEW people_edit
AS
  SELECT * FROM emp
   WHERE ename =
           SYS_CONTEXT ('userenv', 'session_user')
         WITH CHECK OPTION;


SELECT empno, ename, sal
  FROM people_edit;
-- try to update another user's record
UPDATE people_edit
   SET ename = 'Bozo'
 WHERE ename = 'KING';

-- User cannot update their name
-- as doing so breaks view integrity
/********* BUG in Oracle 10g ********/
UPDATE people_edit
   SET ename = 'Bozo'
 WHERE ename = 'SCOTT';
/********* BUG in Oracle 10g ********/


-- Try to delete all records.
DELETE FROM people_edit;
-- Inserts work as long as compliant
-- with view's defintion
INSERT INTO people_edit
            (empno, ename, sal)
     VALUES (7788, 'SCOTT', '3000');
INSERT INTO people_edit
            (empno, ename, sal)
     VALUES (7788, 'SCOTT2', '3000');

----------- Views for CLS ---------------
CONN sec_mgr/sec_mgr
DROP TABLE people_data;
CREATE TABLE
people_data(
username      VARCHAR2(30)
  CONSTRAINT pd_primary_key PRIMARY KEY,
friendly_name VARCHAR2(30),
job           VARCHAR2(9),
salary        NUMBER,
deptno        NUMBER(2)
)
/
INSERT INTO people_data
     VALUES ('SCOTT', 'SCOTT', 'ANALYST', 3000,
             20);
INSERT INTO people_data
     VALUES ('BLAKE', 'BLAKE', 'MANAGER', 2850,
             30);
INSERT INTO people_data
     VALUES ('MARTIN',
             'MARTIN',
             'SALESMAN',
             1250,
             30);
COMMIT ;


CREATE OR REPLACE VIEW people_cls
AS
  SELECT username,
         friendly_name,
         job,
         deptno,
         DECODE (UPPER (username),
                 USER, salary,
                 NULL) salary
    FROM people_data;

/*
CREATE OR REPLACE 
VIEW PEOPLE_CLS
AS 
select username, friendly_name, job, deptno, 
       decode(upper(username),USER,salary,0) salary
  from people_data;
*/

GRANT SELECT
  ON people_cls
  TO scott;
GRANT UPDATE (friendly_name)
  ON people_cls
  TO scott;

CONN scott/tiger
COL username format a15
COL friendly_name format a15
SELECT *
  FROM people_cls;

UPDATE people_cls
   SET friendly_name = 'SCOTTIE'
 WHERE username = 'SCOTT';

UPDATE people_cls
   SET job = 'MANAGER'
 WHERE username = 'SCOTT';

UPDATE people_cls
   SET friendly_name = 'SCOTTIE';
SELECT *
  FROM people_cls;
ROLLBACK ;
