set timing off
drop table t;
create table t(
total number,
t_date date default sysdate);
spool d.log

CREATE OR REPLACE
FUNCTION pred_function
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2
AS
BEGIN
  return 'totl > 100';
END;
/


begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_NAME     => 'T',
                  POLICY_NAME     => 'T_SIUD',
                  POLICY_FUNCTION => 'pred_function');
end;
/

select * from t;

-- note v$vpd_policy only works for successful execution
begin
  DBMS_RLS.ENABLE_POLICY ( 
                  OBJECT_SCHEMA   => 'SEC_MGR',
                  OBJECT_NAME     => 'T',
                  POLICY_NAME     => 'T_SIUD',
                  ENABLE          => FALSE);
end;
/

exec debug_policy('SEC_MGR','T','T_SIUD')

CREATE OR REPLACE
FUNCTION pred_function
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2
AS
BEGIN
  return 'total > 100';
END;
/
begin
  DBMS_RLS.ENABLE_POLICY ( 
                  OBJECT_SCHEMA   => 'SEC_MGR',
                  OBJECT_NAME     => 'T',
                  POLICY_NAME     => 'T_SIUD',
                  ENABLE          => TRUE);
end;
/
exec debug_policy('SEC_MGR','T','T_SIUD')
select * from t;
---------------- test for packages ------------
begin
  DBMS_RLS.DROP_POLICY ( 
                  OBJECT_SCHEMA   => 'SEC_MGR',
                  POLICY_NAME     => 'T_SIUD',
                  OBJECT_NAME     => 'T');
end;
/

create or replace package t_p
as
function pred_function
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2;
end;
/
create or replace package body t_p
as
FUNCTION pred_function
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2
AS
BEGIN
  return 'totl > 100';
END;
END;
/
begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_NAME     => 'T',
                  POLICY_NAME     => 'T_SIUD',
                  POLICY_FUNCTION => 't_p.pred_function');
end;
/
select * from t;

begin
  DBMS_RLS.ENABLE_POLICY ( 
                  OBJECT_SCHEMA   => 'SEC_MGR',
                  OBJECT_NAME     => 'T',
                  POLICY_NAME     => 'T_SIUD',
                  ENABLE          => FALSE);
end;
/

exec debug_policy('SEC_MGR','T','T_SIUD')

--------------- test for sys_context values --
CREATE OR REPLACE 
FUNCTION Dept_Only
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2
AS
BEGIN
  return 
    'deptno = sys_context(''people_ctx'',''deptno'')';
END;
/
begin
  DBMS_RLS.DROP_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE',
                  POLICY_NAME       => 'PEOPLE_SEL');
end;
/
begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE',
                  POLICY_NAME       => 'PEOPLE_SEL',
                  FUNCTION_SCHEMA   => 'SEC_MGR',
                  POLICY_FUNCTION   => 'Dept_Only',
                  STATEMENT_TYPES   => 'SELECT');
end;
/

exec sec_mgr.debug_policy('SEC_MGR','PEOPLE','PEOPLE_SEL')

grant execute on debug_policy to scott;
conn scott/tiger
select ename from people;
exec sec_mgr.debug_policy('SEC_MGR','PEOPLE','PEOPLE_SEL')
select sys_context('people_ctx','deptno') from dual;

conn sec_mgr/sec_mgr
exec print_table('select * from user_policies')
alter table people rename to people$;
create or replace
view people 
as select * from people$;
begin
  DBMS_RLS.DROP_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE$',
                  POLICY_NAME       => 'PEOPLE_SEL');
end;
/
begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE',
                  POLICY_NAME       => 'PEOPLE_SEL',
                  FUNCTION_SCHEMA   => 'SEC_MGR',
                  POLICY_FUNCTION   => 'Dept_Only',
                  STATEMENT_TYPES   => 'SELECT');
end;
/
CREATE OR REPLACE
PROCEDURE people_ctx_mgr
AS 
BEGIN
  for rec in 
    (select deptno 
       from people$
     where ename = USER)
   LOOP
     DBMS_SESSION.set_context (namespace => 'people_ctx', 
                               attribute => 'deptno', 
                               value     => rec.deptno);  
   END LOOP; 
END;
/
revoke all on people$ from scott;
grant all on people to scott;

conn scott/tiger
select sys_context('people_ctx','deptno') from dual;
select ename, deptno from people;
delete from people;

----------------- error when null returned from sys_context

exec print_table('select * from user_policies')

CREATE OR REPLACE 
FUNCTION Dept_Only
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2
AS
BEGIN
  return 
    'deptno = ' || sys_context('people_ctx','deptno');
END;
/
select * from people;
exec debug_policy('SEC_MGR','PEOPLE','PEOPLE_SEL')

spool off
edit d.log
