COL object_owner format a12
COL object_name format a12
COL policy format a6
COL sql_fulltext format a26
COL predicate format a12
SELECT object_owner,
       object_name,
       POLICY,
       sql_fulltext,
       rows_processed num_rows,
       predicate
  FROM v$vpd_policy p, v$sql s
 WHERE p.sql_id = s.sql_id
   AND predicate IS NOT NULL;


COL object_owner format a12
COL object_name format a12
COL policy format a6
COL sql_fulltext format a26
COL predicate format a12
SELECT object_owner,
       object_name,
       POLICY,
       sql_text,
       rows_processed num_rows,
       predicate
  FROM v$vpd_policy p, v$sqlarea s
 WHERE p.sql_id = s.sql_id
   AND predicate IS NOT NULL;
 
 
 CONN sys/oracle as sysdba
 CREATE OR REPLACE VIEW get_trace_filename
 AS
   SELECT    c.VALUE
          || '/'
          || INSTANCE
          || '_ora_'
          || LTRIM (TO_CHAR (a.spid, 'fm99999'))
          || '.trc' filename
     FROM v$process a,
          v$session b,
          v$parameter c,
          v$thread c
    WHERE a.addr = b.paddr
      AND b.audsid = USERENV ('sessionid')
      AND c.NAME = 'user_dump_dest';
 GRANT SELECT ON get_tracefilename TO PUBLIC;
 CREATE PUBLIC SYNONYM get_trace_filename FOR get_trace_filename;


---------- show no-reparse
DECLARE
  l_total  NUMBER;
BEGIN
  EXECUTE IMMEDIATE 'select count(*) from emp'
               INTO l_total;
  DBMS_OUTPUT.put_line (l_total);
END;
/
