conn sec_mgr/sec_mgr
spool c.log
--------------- static OLD ------------
set timing off
begin
  DBMS_RLS.DROP_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE',
                  POLICY_NAME       => 'PEOPLE_SEL_CACHE');
end;
/
begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_SCHEMA         => 'SEC_MGR',
                  OBJECT_NAME           => 'PEOPLE',
                  POLICY_NAME           => 'PEOPLE_SEL_CACHE',
                  FUNCTION_SCHEMA       => 'SEC_MGR',
                  POLICY_FUNCTION       => 'PRED_FUNCTION',
                  STATEMENT_TYPES       => 'SELECT',
                  STATIC_POLICY         =>  TRUE);
end;
/
set timing on
select count(*) "Static OLD 1" from sec_mgr.people;
select count(*) "Static OLD 2" from sec_mgr.people;
exec sec_mgr.people_ctx_mgr;
select count(*) "Static OLD 3" from sec_mgr.people;

--------------- static ------------
set timing off
begin
  DBMS_RLS.DROP_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE',
                  POLICY_NAME       => 'PEOPLE_SEL_CACHE');
end;
/
begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_SCHEMA         => 'SEC_MGR',
                  OBJECT_NAME           => 'PEOPLE',
                  POLICY_NAME           => 'PEOPLE_SEL_CACHE',
                  FUNCTION_SCHEMA       => 'SEC_MGR',
                  POLICY_FUNCTION       => 'PRED_FUNCTION',
                  STATEMENT_TYPES       => 'SELECT',
                  POLICY_TYPE           =>  DBMS_RLS.STATIC);
end;
/
set timing on
select count(*) "Static 1" from sec_mgr.people;
select count(*) "Static 2" from sec_mgr.people;
exec sec_mgr.people_ctx_mgr;
select count(*) "Static 3" from sec_mgr.people;

--------------- context sensitive ------------
set timing off
begin
  DBMS_RLS.DROP_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE',
                  POLICY_NAME       => 'PEOPLE_SEL_CACHE');
end;
/
begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_SCHEMA         => 'SEC_MGR',
                  OBJECT_NAME           => 'PEOPLE',
                  POLICY_NAME           => 'PEOPLE_SEL_CACHE',
                  FUNCTION_SCHEMA       => 'SEC_MGR',
                  POLICY_FUNCTION       => 'PRED_FUNCTION',
                  STATEMENT_TYPES       => 'SELECT',
                  POLICY_TYPE           =>  DBMS_RLS.CONTEXT_SENSITIVE);
end;
/
set timing on
select count(*) "context sensitive 1" from sec_mgr.people;
select count(*) "context sensitive 2" from sec_mgr.people;
exec sec_mgr.people_ctx_mgr;
select count(*) "context sensitive 3" from sec_mgr.people;

--------------- dynamic ------------
set timing off
begin
  DBMS_RLS.DROP_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE',
                  POLICY_NAME       => 'PEOPLE_SEL_CACHE');
end;
/
begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_SCHEMA         => 'SEC_MGR',
                  OBJECT_NAME           => 'PEOPLE',
                  POLICY_NAME           => 'PEOPLE_SEL_CACHE',
                  FUNCTION_SCHEMA       => 'SEC_MGR',
                  POLICY_FUNCTION       => 'PRED_FUNCTION',
                  STATEMENT_TYPES       => 'SELECT',
                  POLICY_TYPE           =>  DBMS_RLS.DYNAMIC);
end;
/
set timing on
select count(*) "DYNAMIC 1" from sec_mgr.people;
select count(*) "DYNAMIC 2" from sec_mgr.people;
exec sec_mgr.people_ctx_mgr;
select count(*) "DYNAMIC 3" from sec_mgr.people;
spool off
begin
  DBMS_RLS.DROP_POLICY ( 
                  OBJECT_SCHEMA     => 'SEC_MGR',
                  OBJECT_NAME       => 'PEOPLE',
                  POLICY_NAME       => 'PEOPLE_SEL_CACHE');
end;
/

edit c.log
