set timing off
drop table t;
create table t(
total number,
t_date date default sysdate);

CREATE OR REPLACE
FUNCTION pred_function
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2
AS
l_total_recs number;
BEGIN
  select count(*) into l_total_recs
    from people;
  return 'total = ' || l_total_recs;
END;
/

begin
  DBMS_RLS.ADD_POLICY ( 
                  OBJECT_NAME     => 'T',
                  POLICY_NAME     => 'T_SIUD',
                  POLICY_FUNCTION => 'pred_function');
end;
/

select * from t;
alter table people rename to people$;
select * from t;

alter function pred_function compile;
show errors
 
CREATE OR REPLACE
FUNCTION pred_function
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2
AS
BEGIN
  return 'totl > 100';
END;
/

select * from t;

-- note v$vpd_policy only works for successful execution
begin
  DBMS_RLS.ENABLE_POLICY ( 
                  OBJECT_SCHEMA   => 'SEC_MGR',
                  OBJECT_NAME     => 'T',
                  POLICY_NAME     => 'T_SIUD',
                  ENABLE          => FALSE);
end;
/

select pred_function "Policy Predicate"
  from dual;

declare
l_sql_str varchar2(2000);
begin
  l_sql_str := 'select * from t where ' || pred_function;
  dbms_output.put_line('-------- SQL String -----------');
  dbms_output.put_line(l_sql_str);
  dbms_output.put_line('------ End SQL String ---------');
  execute immediate l_sql_str;  
end;
/

CREATE OR REPLACE
FUNCTION pred_function
           (p_schema in varchar2 default NULL,
            p_object in varchar2 default NULL)
RETURN varchar2
AS
BEGIN
  return 'total > 100';
END;
/
begin
  DBMS_RLS.ENABLE_POLICY ( 
                  OBJECT_SCHEMA   => 'SEC_MGR',
                  OBJECT_NAME     => 'T',
                  POLICY_NAME     => 'T_SIUD',
                  ENABLE          => TRUE);
end;
/
select * from t;

