CONN sec_mgr/sec_mgr
-- add hiding

BEGIN
  sa_policy_admin.remove_table_policy
                   (policy_name    => 'ESBD',
                    schema_name    => 'SCOTT',
                    table_name     => 'ANNOUNCEMENTS');
END;
/

-- cannot re-add to table

BEGIN
  sa_policy_admin.apply_table_policy
    (policy_name      => 'ESBD',
     schema_name      => 'SCOTT',
     table_name       => 'ANNOUNCEMENTS',
     table_options    => 'HIDE,LABEL_DEFAULT,READ_CONTROL');
END;
/

CONN scott/tiger
DROP TABLE announce_copy;
-- table cannot be created
-- with select * or with rowlabel already existing
CREATE TABLE announce_copy
(MESSAGE VARCHAR2(4000));
GRANT ALL ON announce_copy TO sec_mgr;
DESC announce_copy

CONN sec_mgr/sec_mgr
-- need to add the label column

BEGIN
  sa_policy_admin.apply_table_policy
    (policy_name      => 'ESBD',
     schema_name      => 'SCOTT',
     table_name       => 'ANNOUNCE_COPY',
     table_options    => 'HIDE,LABEL_DEFAULT,READ_CONTROL');
END;
/

EXEC sa_session.set_access_profile('ESBD','ALL_EXECS');
-- fails now that column is hidden
-- if we ommited the rowlabel, the default session label would be
-- applied to all rows
INSERT INTO scott.announce_copy
  (SELECT MESSAGE, ROWLABEL
     FROM scott.announcements);
INSERT INTO scott.announce_copy
            (MESSAGE, ROWLABEL)
  (SELECT MESSAGE, ROWLABEL
     FROM scott.announcements);
COMMIT ;
/**************
exec sa_session.set_access_profile('ESBD','ALL_EXECS');
col "OLS Label" format a12
col message format a63
select message, 
       label_to_char(rowlabel) "OLS Label" 
  from scott.announce_copy;
***************/

BEGIN
  sa_policy_admin.apply_table_policy
                 (policy_name      => 'ESBD',
                  schema_name      => 'SCOTT',
                  table_name       => 'ANNOUNCEMENTS',
                  table_options    => 'READ_CONTROL');
END;
/

EXEC sa_session.set_access_profile('ESBD','ALL_EXECS');
SELECT COUNT (*) || ' ANNOUNCEMENTS messages.'
                        "Record Count Comparison"
  FROM scott.announcements
UNION ALL
SELECT COUNT (*) || ' ANNOUNCE_COPY messages.'
  FROM scott.announce_copy;
EXEC sa_session.set_access_profile('ESBD','NY_SALES_REP');
/
EXEC sa_session.set_access_profile('ESBD','US_SALES_MGR');
/
-- drop policy

BEGIN
  sa_policy_admin.remove_table_policy
                   (policy_name    => 'ESBD',
                    schema_name    => 'SCOTT',
                    table_name     => 'ANNOUNCEMENTS');
  sa_policy_admin.remove_table_policy
                    (policy_name    => 'ESBD',
                     schema_name    => 'SCOTT',
                     table_name     => 'ANNOUNCE_COPY');
END;
/

CONN scott/tiger
DESC announcements
DROP TABLE announcements;
ALTER TABLE announce_copy RENAME TO announcements;
DESC announcements
CONN sec_mgr/sec_mgr

BEGIN
  sa_policy_admin.apply_table_policy
    (policy_name      => 'ESBD',
     schema_name      => 'SCOTT',
     table_name       => 'ANNOUNCEMENTS',
     table_options    => 'HIDE,LABEL_DEFAULT,READ_CONTROL');
END;
/

DESC scott.announcements

CONN sec_mgr/sec_mgr
EXEC sa_session.set_access_profile('ESBD','NY_SALES_REP');
SELECT *
  FROM scott.announcements;
COL message format a63
COL "OLS Label" format a12
SELECT MESSAGE,
       label_to_char (ROWLABEL) "OLS Label"
  FROM scott.announcements;
