COL "OLS Label" format a12
COL message format a63
COL "Read Label" format a30
COL "Write Label" format a30

CONN sec_mgr/sec_mgr
-- turn on label_update

BEGIN
  sa_policy_admin.remove_table_policy
                   (policy_name    => 'ESBD',
                    schema_name    => 'SCOTT',
                    table_name     => 'ANNOUNCEMENTS');
  sa_policy_admin.apply_table_policy
    (policy_name      => 'ESBD',
     schema_name      => 'SCOTT',
     table_name       => 'ANNOUNCEMENTS',
     table_options    =>    'HIDE,LABEL_DEFAULT,LABEL_UPDATE,'
                         || 'WRITE_CONTROL,READ_CONTROL');
END;
/

BEGIN
  sa_user_admin.drop_user_access
                        (policy_name    => 'ESBD',
                         user_name      => 'ALL_EXECS');
  sa_user_admin.set_user_labels
     (policy_name        => 'ESBD',
      user_name          => 'ALL_EXECS',
      max_read_label     => 'EXEC:IS,DEV,SALES:CORP',
      max_write_label    => 'EXEC:IS,DEV,SALES:CORP',
      min_write_label    => 'EMP',
      def_label          => 'EXEC:IS,DEV,SALES:CORP',
      row_label          => 'EXEC');
END;
/


-- set profile to executves
EXEC sa_session.set_access_profile('ESBD','ALL_EXECS');
SELECT sa_session.read_label ('ESBD')
                                     "Read Label",
       sa_session.write_label ('ESBD')
                                    "Write Label"
  FROM DUAL;
-- show data
SELECT MESSAGE,
       label_to_char (ROWLABEL) "OLS Label"
  FROM scott.announcements;
-- show we can update the data
EXEC sa_session.set_access_profile('ESBD','ALL_EXECS');
UPDATE scott.announcements
   SET MESSAGE = INITCAP (MESSAGE);
-- try to re-classify
UPDATE scott.announcements
   SET ROWLABEL = char_to_label ('ESBD', 'EMP')
 WHERE label_to_char (ROWLABEL) = 'MGR'
/
-- grant write down privilege

BEGIN
  sa_user_admin.set_user_privs
                       (policy_name    => 'ESBD',
                        user_name      => 'ALL_EXECS',
                        PRIVILEGES     => 'WRITEDOWN');
END;
/

-- need to reset authorizations
EXEC sa_session.set_access_profile('ESBD','ALL_EXECS');
-- 
UPDATE scott.announcements
   SET ROWLABEL = char_to_label ('ESBD', 'EMP')
 WHERE label_to_char (ROWLABEL) = 'MGR:DEV'
/
ROLLBACK ;
