-- Securing Access to Default Accounts
CONN SEC_MGR

REVOKE CONNECT, CREATE SESSION FROM MDSYS;
ALTER USER MDSYS IDENTIFIED BY ti1hp2r4m;

-- Securing Access to Application Schemas
CREATE OR REPLACE TRIGGER logon_check
  AFTER LOGON ON DATABASE
BEGIN
  IF (SYS_CONTEXT ('USERENV', 'SESSION_USER') = 'SCOTT')
  THEN
    raise_application_error (-20001, 'Unauthorized Login');
  END IF;
END;
/

-- test logon trigger
CONN scott/tiger

-- View users with 'ADMINISTER DATABASE TRIGGER' privilege
CONN sec_mgr
SELECT grantee
  FROM dba_sys_privs
 WHERE PRIVILEGE = 'ADMINISTER DATABASE TRIGGER';
