CONN sec_mgr

CREATE OR REPLACE FUNCTION is_auth_password (
  p_username  IN  VARCHAR2,
  p_password  IN  VARCHAR2)
  RETURN BOOLEAN
AS
  l_orig_password_verifier  dba_users.PASSWORD%TYPE;
  l_new_password_verifier   dba_users.PASSWORD%TYPE;
BEGIN
  SELECT PASSWORD
    INTO l_orig_password_verifier
    FROM dba_users
   WHERE username = UPPER (p_username);
  EXECUTE IMMEDIATE    'alter user '
                    || p_username
                    || ' identified by '
                    || p_password;
  SELECT PASSWORD
    INTO l_new_password_verifier
    FROM dba_users
   WHERE username = UPPER (p_username);
  EXECUTE IMMEDIATE    'alter user '
                    || p_username
                    || ' identified by values '''
                    || l_orig_password_verifier
                    || '''';
  RETURN l_orig_password_verifier = l_new_password_verifier;
END;
/

show errors

-- Test program

BEGIN
  IF (is_auth_password ('scott', 'tiger') = TRUE)
  THEN
    DBMS_OUTPUT.put_line ('scott/tiger is valid');
  ELSE
    DBMS_OUTPUT.put_line ('scott/tiger is NOT valid');
  END IF;

  IF (is_auth_password ('scott', 'lion') = TRUE)
  THEN
    DBMS_OUTPUT.put_line ('scott/lion is valid');
  ELSE
    DBMS_OUTPUT.put_line ('scott/lion is NOT valid');
  END IF;
END;
/
