conn sec_mgr
-- Resource Limits
SELECT resource_name, LIMIT
  FROM dba_profiles
 WHERE PROFILE = 'DEFAULT'
   AND resource_type = 'KERNEL';

-- Default Roles: CONNECT
SELECT PRIVILEGE
  FROM dba_sys_privs
 WHERE grantee = 'CONNECT';

-- Default Roles: RESOURCE
SELECT PRIVILEGE
  FROM dba_sys_privs
 WHERE grantee = 'RESOURCE';

CREATE USER unlim IDENTIFIED BY VALUES 'noPassword';
-- user has no privileges
SELECT *
  FROM dba_sys_privs
 WHERE grantee = 'UNLIM';
-- grant resource role to user
GRANT RESOURCE TO unlim;
-- note the user now has unlimited quotas
SELECT PRIVILEGE
  FROM dba_sys_privs
 WHERE grantee = 'UNLIM';
