CREATE TABLE user_prefs
(background_color VARCHAR2(6),
foreground_color VARCHAR2(6),
font_style VARCHAR2(20));
GRANT SELECT ON user_prefs TO PUBLIC;
ALTER TABLE user_prefs ADD favorite_links VARCHAR2(250);

-- PUBLIC Access to the Database Metadata
SELECT table_name
  FROM dba_tab_privs
 WHERE grantee = 'PUBLIC'
   AND owner = 'SYS'
   AND PRIVILEGE = 'SELECT'
   AND table_name LIKE 'ALL%';

-- Broken Objects
SELECT COUNT (*)
  FROM all_objects
 WHERE status = 'INVALID';

REVOKE SELECT ON all_users FROM PUBLIC;

SELECT COUNT (*)
  FROM all_objects
 WHERE status = 'INVALID';

-- Show whose objects are broken.
SELECT DISTINCT owner
           FROM all_objects
          WHERE status = 'INVALID';

-- create list of users who require
-- direct select privileges on ALL_USERS
SELECT DISTINCT 'grant select on all_users to ' || owner || ';'
                                                            sql_command
           FROM (SELECT DISTINCT owner
                            FROM all_objects
                           WHERE status = 'INVALID' AND owner != 'SYS'
                 MINUS
                 SELECT grantee
                   FROM dba_sys_privs
                  WHERE PRIVILEGE = 'SELECT ANY DICTIONARY');

-- PUBLIC Privileges on Programs
SELECT   table_name
    FROM dba_tab_privs
   WHERE     grantee = 'PUBLIC'
         AND owner = 'SYS'
         AND PRIVILEGE = 'EXECUTE'
         AND table_name LIKE 'DBMS%'
      OR table_name LIKE 'UTL%'
ORDER BY 1;
