ALTER USER scott GRANT CONNECT THROUGH app_user;
ALTER USER blake GRANT CONNECT THROUGH app_user;

-- create database role
CREATE ROLE app_a_role;
-- grant role to user
GRANT  app_a_role TO scott;
-- disable role by default
ALTER USER scott DEFAULT ROLE ALL EXCEPT app_a_role;
-- grant proxy privileges along with
-- ability to eanble the app_a_role
ALTER  USER scott GRANT CONNECT THROUGH app_user
              WITH ROLE app_a_role;


-- this disallows any roles to be set
ALTER USER scott GRANT CONNECT THROUGH app_user 
  WITH NO ROLES;

--this allows all roles but DBA
ALTER USER scott GRANT CONNECT THROUGH app_user 
  WITH ROLE ALL EXCEPT DBA;

SELECT ROLE FROM session_roles;

ALTER USER scott
    GRANT CONNECT THROUGH app_user
    WITH ROLE ALL EXCEPT RESOURCE;

ALTER USER scott
    GRANT CONNECT THROUGH app_user
    AUTHENTICATED USING PASSWORD;

-- not enforced
ALTER USER scott
    GRANT CONNECT THROUGH app_public
    AUTHENTICATED USING DISTINGUISHED NAME;

