CREATE OR REPLACE PACKAGE user_info
AS
  PROCEDURE set_name (p_name IN VARCHAR2);

  FUNCTION get_name
    RETURN VARCHAR2;
END;
/

CREATE OR REPLACE PACKAGE BODY user_info
AS
  g_name  VARCHAR2 (32767);

  PROCEDURE set_name (p_name IN VARCHAR2)
  AS
  BEGIN
    g_name := UPPER (p_name);
  END;

  FUNCTION get_name
    RETURN VARCHAR2
  AS
  BEGIN
    RETURN g_name;
  END;
END;
/

DROP TABLE people;
CREATE TABLE people_tab AS SELECT * FROM scott.emp;
CREATE OR REPLACE VIEW person_view
AS
  SELECT *
    FROM people_tab
   WHERE ename = user_info.get_name;

-- page 136
-- set the user's identity
EXEC user_info.set_name('SCOTT');
-- get all rows for the user
SELECT ename, job, sal
  FROM person_view;

-- reset all package variables
EXEC dbms_session.reset_package;
-- show session state has been reset
SELECT * FROM person_view;

-- grant privileges to APP_PUBLIC
grant execute on user_info to APP_PUBLIC;
