CONN sec_mgr

EXEC dbms_session.set_identifier('SCOTT');
COL username format a15
SELECT SYS_CONTEXT ('userenv',
                    'client_identifier') username
  FROM DUAL;
-- replace view
CREATE OR REPLACE VIEW person_view
AS
  SELECT *
    FROM people_tab
   WHERE ename =
           SYS_CONTEXT ('userenv',
                        'client_identifier');

-- get all rows for the user
SELECT ename, job, sal
  FROM person_view;

-- reset value
EXEC dbms_session.clear_identifier;
SELECT * FROM person_view;


------------------- Securing Client Identifiers -----------
CONN sys/oracle as sysdba
GRANT EXECUTE ON DBMS_SESSION TO sec_mgr;

CONN sec_mgr/oracle10g

CREATE OR REPLACE PACKAGE client_info_mgr
AS
  PROCEDURE set_info (p_info IN VARCHAR2);

  PROCEDURE clear_info;
END;
/

CREATE OR REPLACE PACKAGE BODY client_info_mgr
AS
  PROCEDURE set_info (p_info IN VARCHAR2)
  AS
  BEGIN
    -- Optionally perform any validation 
    -- or verification prior to setting value
    SYS.DBMS_SESSION.set_identifier (p_info);
  END;

  PROCEDURE clear_info
  AS
  BEGIN
    SYS.DBMS_SESSION.clear_identifier;
  END;
END;
/
-- grant execute privileges to our connection 
-- pool schema
GRANT EXECUTE ON client_info_mgr TO app_public;

-- test package
EXEC client_info_mgr.set_info('KING');
SELECT SYS_CONTEXT ('userenv',
                    'client_identifier') username
  FROM DUAL;
EXEC client_info_mgr.clear_info;
SELECT SYS_CONTEXT ('userenv',
                    'client_identifier') username
  FROM DUAL;


