-- set username in both places
EXEC user_info.set_name('SCOTT');
EXEC dbms_session.set_identifier('SCOTT');
COL client_id format a15
COL program_name format a15
-- show values are consistent
SELECT SYS_CONTEXT ('userenv',
                    'client_identifier')
                                        client_id,
       user_info.get_name program_name
  FROM DUAL;
-- Ensure Client ID and User info
-- are consistent before returning rows
CREATE OR REPLACE VIEW person_view
AS
  SELECT *
    FROM people_tab
   WHERE ename = user_info.get_name
     AND user_info.get_name =
           SYS_CONTEXT ('userenv',
                        'client_identifier');
-- test database security
SELECT ename, job, sal
  FROM person_view;
-- change publicly available client identifier
EXEC dbms_session.set_identifier('KING');
-- Note user cannot change user_info as 
-- it should be protected
SELECT * FROM person_view;
