drop role a;
drop role b;
drop role c;
drop role d;
drop role e;

drop role app_1;
-- create a password protected role
CREATE ROLE app_1 identified by thisSuperSecretPassword;
-- grant DBA role to protected role
GRANT DBA TO app_1;
-- make protected role an eligible role for SCOTT.
GRANT app_1 TO scott;
-- critical mistake, defaulting APP_1 makes it enabled
ALTER USER scott DEFAULT ROLE ALL;
CONN scott/tiger
-- DBA role and all roles granted to DBA are enabled
SELECT ROLE FROM session_roles;




-- ensure no one has table privs
SELECT grantee
  FROM dba_tab_privs
 WHERE owner = 'SEC_MGR' AND table_name = 'T';
SELECT grantee
  FROM dba_sys_privs
 WHERE PRIVILEGE = 'SELECT ANY TABLE';

create user APP_PUBLIC identified by tiarhpw2r
   default tablespace users
   temporary tablespace temp;


grant CREATE SESSION to APP_PUBLIC;


alter user APP_PUBLIC_GLOBAL 
  grant connect through APP_PUBLIC 
  authenticated using DISTINGUISHED NAME;
  
  
select sys_context('userenv', 'PROXY_USER') "Conn Pool",
  sys_context('userenv', 'SESSION_USER') "Mapped Schema",
  sys_context('userenv', 'EXTERNAL_NAME') "End User"
from dual;
  
revoke execute on SYS.DBMS_SESSION from PUBLIC;

create or replace procedure set_client_info (p_info in varchar2)
as
begin
  SYS.DBMS_SESSION.SET_IDENTIFIER(p_info);
end;
/
grant execute on set_client_info to APP_PUBLIC_GLOBAL;

set serveroutput on
declare
s varchar2(2000);
begin
  for rec in (select * from all_objects where status = 'INVALID' and (object_type = 'PACKAGE BODY' OR object_type = 'PACKAGE' OR object_type = 'PROCEDURE'))
  LOOP
   s:= 'alter package '  || rec.owner ||'.'|| rec.object_name || ' compile';
   if (rec.object_type = 'PACKAGE_BODY') THEN
     s:= s || ' body';
   end if;
   dbms_output.put_line(s);
    execute immediate s;
  end loop;
end;
/

select object_name, object_type from all_objects where status = 'INVALID';

drop profile esbd_app_profile cascade;
CREATE PROFILE esbd_app_profile LIMIT
    SESSIONS_PER_USER 10;
alter user APP_PUBLIC profile esbd_app_profile;
alter system set resource_limit=true;

