SPOOL adminPrivs.log
CONN system/manager

CREATE USER data_owner IDENTIFIED BY VALUES 'no login'
DEFAULT TABLESPACE users
TEMPORARY TABLESPACE temp;
ALTER USER data_owner
    QUOTA 10 m
    ON "USERS";
-- create table
CREATE TABLE data_owner.t AS SELECT * FROM DUAL;
-- create procedure

CREATE PROCEDURE data_owner.foo
AS
BEGIN
  NULL;
END;
/

-- create a junior security officer
CREATE USER sec_mgr_jr IDENTIFIED BY sec_mgr_jr;
GRANT CREATE ROLE TO sec_mgr_jr;
-- delegate privs to the junior security officer
-- object privs
GRANT ALL ON data_owner.t TO sec_mgr_jr
  WITH GRANT OPTION;
GRANT EXECUTE ON data_owner.foo TO sec_mgr_jr
  WITH GRANT OPTION;
-- system privs
GRANT ALTER SESSION TO sec_mgr_jr WITH ADMIN OPTION;
GRANT CREATE SESSION TO sec_mgr_jr WITH ADMIN OPTION;
GRANT CREATE SYNONYM TO sec_mgr_jr WITH ADMIN OPTION;
GRANT CREATE SEQUENCE TO sec_mgr_jr WITH ADMIN OPTION;

-- create a user for this example
CREATE USER some_user IDENTIFIED BY some_user;

-- as junior security officer, grant privs to some user
CONNECT sec_mgr_jr/sec_mgr_jr
CREATE ROLE data_owner_access;

-- grant direct object privs
GRANT SELECT ON data_owner.t TO some_user;
GRANT EXECUTE ON data_owner.foo TO some_user;
-- grant role object privs
GRANT INSERT ON data_owner.t TO data_owner_access;
GRANT data_owner_access TO some_user;

-- grant direct system privs
GRANT ALTER SESSION TO some_user;
GRANT CREATE SESSION TO some_user;
-- grant role system privs
GRANT CREATE SYNONYM TO data_owner_access;
GRANT CREATE SEQUENCE TO data_owner_access;

-- show some user can connect and query table
CONNECT some_user/some_user
SELECT *
  FROM session_roles;
COL PRIVILEGE FORMAT A15
COL OWNER FORMAT A15
COL TABLE_NAME FORMAT A15
SELECT *
  FROM user_object_privs
 WHERE owner = 'DATA_OWNER';
SELECT *
  FROM user_system_privs;
DESC data_owner.t
CONN system/manager
-- drop junior security officer
-- this drops the object privilege
-- but does not drop the system privilege
DROP USER sec_mgr_jr CASCADE;
CONNECT some_user/some_user
SELECT *
  FROM session_roles;
DESC data_owner.t
SELECT *
  FROM user_object_privs
 WHERE owner = 'DATA_OWNER';
SELECT *
  FROM user_system_privs;

SPOOL off
EDIT adminPrivs.log
CONN system/manager
DROP USER data_owner CASCADE;
DROP USER some_user CASCADE;
DROP ROLE data_owner_access;
