CONN system/manager
drop user sec_mgr_jr cascade;
-- create procedure to reset passwords
-- note procedure is in the SEC_MGR schema
CREATE OR REPLACE PROCEDURE sec_mgr.reset_pwd (
  p_username  IN  VARCHAR2,
  p_pwd       IN  VARCHAR2)
AS
BEGIN
  EXECUTE IMMEDIATE    'alter user '
                    || p_username
                    || ' identified by '
                    || p_pwd;
END;
/
-- create junior security administrator
CREATE USER sec_mgr_jr IDENTIFIED BY jr
DEFAULT TABLESPACE users TEMPORARY TABLESPACE temp;
-- only requires two privileges
GRANT CREATE SESSION TO sec_mgr_jr;
GRANT EXECUTE ON sec_mgr.reset_pwd TO sec_mgr_jr;

CONN sec_mgr_jr/jr
-- show use cannot change password
ALTER USER scott IDENTIFIED BY NEW;
-- user procedure to change password
EXEC sec_mgr.reset_pwd('SCOTT','new');
-- prove password has been changed
CONN scott/tiger
CONN scott/new


CONN sec_mgr/oracle10g
drop role rights_role;
CREATE ROLE rights_role;
GRANT SELECT ON data_owner.t TO rights_role;
GRANT rights_role TO scott;
alter user scott default role all;
CONN scott/tiger
-- use role rights in anonymous block
-- to query table
DECLARE
  l_total_rows  PLS_INTEGER := 0;
BEGIN
  SELECT COUNT (*)
    INTO l_total_rows
    FROM data_owner.t;
  DBMS_OUTPUT.put_line ('Total rows: ' || l_total_rows);
END;
/
-- named PL/SQL procedure disables all roles
CREATE OR REPLACE PROCEDURE print_rows
AS
  l_total_rows  PLS_INTEGER := 0;
BEGIN
  SELECT COUNT (*)
    INTO l_total_rows
    FROM data_owner.t;
  DBMS_OUTPUT.put_line ('Total rows: ' || l_total_rows);
END;
/
sho errors

CREATE OR REPLACE PROCEDURE print_rows
AUTHID CURRENT_USER
AS
  l_total_rows  PLS_INTEGER     := 0;
  l_sql         VARCHAR2 (2000);
BEGIN
  l_sql := 'SELECT COUNT (*) ' || 'FROM data_owner.t';
  EXECUTE IMMEDIATE l_sql
               INTO l_total_rows;
  DBMS_OUTPUT.put_line ('Total rows: ' || l_total_rows);
END;
/
EXEC print_rows

