CREATE ROLE sec_app_role IDENTIFIED USING sec_mgr.priv_mgr;
-- grant roles to scott;
GRANT sec_app_role TO scott;
-- disable role. user has to enable to get the privileges
ALTER USER scott DEFAULT ROLE CONNECT, RESOURCE;

-- grant select on table to role
GRANT SELECT ON data_owner.t TO sec_app_role;

-- create SAR
-- This procedure has to be created with invoker rights

CREATE OR REPLACE PROCEDURE priv_mgr
AUTHID CURRENT_USER
AS
BEGIN
  IF (SYS_CONTEXT ('userenv', 'ip_address') =
                                           '127.0.0.1')
  THEN
    DBMS_SESSION.set_role ('sec_app_role');
  END IF;
END;
/
-- grant execute privileges
GRANT EXECUTE ON priv_mgr TO scott;



CONN scott/tiger
SELECT SYS_CONTEXT ('userenv', 'ip_address') FROM DUAL;
SELECT ROLE FROM session_roles;
-- show role cannot be enabled
EXEC dbms_session.set_role('sec_app_role');
EXEC sec_mgr.priv_mgr
SELECT * FROM data_owner.t;
SELECT ROLE FROM session_roles;


-- reset IP address
SELECT SYS_CONTEXT ('userenv', 'ip_address') FROM DUAL;
EXEC sec_mgr.priv_mgr
SELECT * FROM data_owner.t;
SELECT ROLE FROM session_roles;

conn sec_mgr/oracle10g
-- modify security policy to only allow privs
-- during 8 a.m. to 5 p.m.
CREATE OR REPLACE PROCEDURE priv_mgr
AUTHID CURRENT_USER
AS
BEGIN
  IF (    SYS_CONTEXT ('userenv', 'ip_address') =
                                           '127.0.0.1'
      AND TO_CHAR (SYSDATE, 'HH24') BETWEEN 8 AND 17)
  THEN
    DBMS_SESSION.set_role ('sec_app_role');
  END IF;
END;
/
CONN scott/tiger
COL ip format a16
COL hour format a5
SELECT SYS_CONTEXT ('userenv', 'ip_address') ip,
       TO_CHAR (SYSDATE, 'HH24') HOUR
  FROM DUAL;
EXEC sec_mgr.priv_mgr
SELECT * FROM data_owner.t;


ALTER USER scott
    GRANT CONNECT THROUGH app_public
    WITH ROLE sec_app_role;
