CONN system/manager

CREATE USER data_owner IDENTIFIED BY VALUES 'no login'
DEFAULT TABLESPACE users
TEMPORARY TABLESPACE temp;
ALTER USER data_owner
    QUOTA 10 m
    ON "USERS";
-- create table
CREATE TABLE data_owner.t AS SELECT * FROM DUAL;
-- create procedure

CREATE PROCEDURE data_owner.foo
AS
BEGIN
  NULL;
END;
/

GRANT CREATE ROLE TO sec_mgr;
-- delegate privs to the junior security officer
-- object privs
GRANT ALL ON data_owner.t TO sec_mgr
  WITH GRANT OPTION;
GRANT EXECUTE ON data_owner.foo TO sec_mgr
  WITH GRANT OPTION;

CREATE OR REPLACE PROCEDURE set_privs
AS
BEGIN
  EXECUTE IMMEDIATE    'grant select on DATA_OWNER.T to '
                    || USER;
END;
/

CREATE OR REPLACE PROCEDURE unset_privs
AS
BEGIN
  EXECUTE IMMEDIATE    'revoke select on DATA_OWNER.T from '
                    || USER;
END;
/

GRANT EXECUTE ON set_privs TO scott;
GRANT EXECUTE ON unset_privs TO scott;
CONN scott/tiger
SELECT *
  FROM data_owner.t;
EXEC sec_mgr.set_privs
SELECT *
  FROM data_owner.t;
EXEC sec_mgr.unset_privs

-------------  create role and grant role to user
DROP ROLE app_user_role;
-- create role for application users
CREATE ROLE app_user_role;
-- grant privileges to role
GRANT ALL ON data_owner.t TO app_user_role;
-- grant role to user(s)
GRANT app_user_role TO scott;
-- disable this role by default
-- privileges are not available till role is enabled
ALTER USER scott DEFAULT ROLE ALL EXCEPT app_user_role;


CONN scott/tiger
SELECT * FROM data_owner.t;
SET ROLE app_user_role;
SELECT * FROM data_owner.t;
