CREATE OR REPLACE PACKAGE show_roles
AS
  PROCEDURE display (p_username IN VARCHAR2);
END;
/

CREATE OR REPLACE PACKAGE BODY show_roles
AS
--------------------------------------------------------
  FUNCTION convert_level (p_level IN NUMBER)
    RETURN VARCHAR2
  AS
    l_str  VARCHAR2 (32767);
  BEGIN
    FOR i IN 1 .. p_level
    LOOP
      l_str := l_str || '..';
    END LOOP;

    RETURN l_str;
  END;

--------------------------------------------------------
  PROCEDURE recursive_role_getter (
    p_role   IN  VARCHAR2,
    p_level  IN  NUMBER)
  AS
  BEGIN
    FOR irec IN (SELECT   granted_role
                     FROM dba_role_privs
                    WHERE grantee = UPPER (p_role)
                 ORDER BY 1)
    LOOP
      DBMS_OUTPUT.put_line (   'Indirect Role: '
                            || convert_level (p_level)
                            || irec.granted_role
                            || ' via '
                            || p_role);
      recursive_role_getter (irec.granted_role,
                             p_level + 1);  -- recurse
    END LOOP;
  EXCEPTION
    WHEN OTHERS
    THEN
      NULL;
  END;

--------------------------------------------------------
  PROCEDURE display (p_username IN VARCHAR2)
  AS
  BEGIN
    FOR rec IN (SELECT   granted_role
                    FROM dba_role_privs
                   WHERE grantee = UPPER (p_username)
                ORDER BY 1)
    LOOP
      DBMS_OUTPUT.put_line (   'Direct Role:   '
                            || rec.granted_role);
      recursive_role_getter (rec.granted_role, 1);
    END LOOP;
  END;
--------------------------------------------------------
END;
/