CONN sec_mgr/oracle10g
DROP TABLE t;
DROP PUBLIC SYNONYM t_synonym;

CREATE  TABLE t AS SELECT * FROM DUAL;
CREATE PUBLIC SYNONYM t_synonym FOR sec_mgr.t;
-- privilege to access T given to synonym
GRANT  SELECT ON t_synonym TO scott;

CONN scott/tiger
-- direct access to object
SELECT * FROM sec_mgr.t;

-- dropping synonym does not 
-- delete access to base object
DROP PUBLIC SYNONYM t_synonym;

CONN scott/tiger
SELECT *
  FROM sec_mgr.t;


--------- redundant privileges system and object --------
CONN system/manager
GRANT SELECT ANY TABLE TO scott;

CONN sec_mgr/oracle10g
REVOKE SELECT ON t FROM scott;

CONN scott/tiger
SELECT *
  FROM sec_mgr.t;
