conn aud_mgr/am

-- create a procedure to be called from FGA
CREATE OR REPLACE 
PROCEDURE prevent (object_schema VARCHAR2, 
                   object_name VARCHAR2, 
                   policy_name VARCHAR2)
AS
BEGIN
 -- no body causes in invalid procedure
END;
/
BEGIN
  DBMS_FGA.ADD_POLICY(object_schema=>'SCOTT', 
                      object_name=>'EMP', 
                      policy_name=>'FGA_FILTER', 
                      audit_condition=>'ename != user', 
                      audit_column => 'SAL', 
                      handler_schema=>'AUD_MGR', 
                      handler_module=>'PREVENT');
END;
/


conn scott/tiger
select ename, sal from scott.emp;


-- testing values
conn sys/oracle as sysdba
exec DBMS_FGA.DROP_POLICY( object_schema => 'SCOTT', object_name   => 'EMP', policy_name   => 'FGA_FILTER' );
delete from sys.fga_log$;
drop procedure aud_mgr.PREVENT;
commit;

conn aud_mgr/am
drop table log;
create table log
(d varchar2(2000));

CREATE OR REPLACE 
TRIGGER set_default_client_info
AFTER LOGON ON DATABASE
DECLARE
l_serial# number;
BEGIN
  select serial# into l_serial# from v$session 
    where audsid = userenv('sessionid');
  dbms_session.set_identifier(sys_context('userenv','sessionid') ||
                              ',' || l_serial#);
END;
/
sho errors

-- create a procedure to be called from FGA
CREATE OR REPLACE 
PROCEDURE prevent (object_schema VARCHAR2, 
                   object_name VARCHAR2, 
                   policy_name VARCHAR2)
AS
BEGIN
insert into log values('id: ' ||sys_context('userenv','client_identifier'));
END;
/
BEGIN
  DBMS_FGA.ADD_POLICY(object_schema=>'SCOTT', 
                      object_name=>'EMP', 
                      policy_name=>'FGA_FILTER', 
                      audit_condition=>'ename != user', 
                      audit_column => 'SAL', 
                      handler_schema=>'AUD_MGR', 
                      handler_module=>'PREVENT');
END;
/


conn scott/tiger
select ename, sal from scott.emp;

conn aud_mgr/am
select * from log;
exec show_aud

conn sys/oracle as sysdba
exec DBMS_FGA.DROP_POLICY( object_schema => 'SCOTT', object_name   => 'EMP', policy_name   => 'FGA_FILTER' );
delete from sys.fga_log$;
drop procedure aud_mgr.PREVENT;
commit;



