CONN sec_mgr/oracle10g
CREATE OR REPLACE TRIGGER set_default_client_info
  AFTER LOGON ON DATABASE
BEGIN
  FOR rec IN (SELECT SID, serial#
                FROM v$session
               WHERE audsid =
                            USERENV ('sessionid')
                 AND ROWNUM <= 1)
  LOOP
    DBMS_SESSION.set_identifier (   rec.SID
                                 || ','
                                 || rec.serial#);
  END LOOP;
END;
/
CONN scott/tiger
COL Kill_Info format a10
SELECT SYS_CONTEXT ('userenv',
                    'client_identifier')
                                        kill_info
  FROM DUAL;

CONN sys/oracle as sysdba
EXEC DBMS_FGA.DROP_POLICY( object_schema => 'SCOTT', object_name   => 'EMP', policy_name   => 'FGA_FILTER' );
DELETE FROM SYS.fga_log$;
COMMIT ;

CREATE OR REPLACE PROCEDURE kill_me
AS
BEGIN
  EXECUTE IMMEDIATE    'ALTER SYSTEM KILL SESSION '''
                    || SYS_CONTEXT
                              ('userenv',
                               'client_identifier')
                    || '''';
  EXECUTE IMMEDIATE    'ALTER USER '
                    || SYS_CONTEXT ('userenv',
                                    'session_user')
                    || ' ACCOUNT LOCK';
END;
/

CREATE OR REPLACE PROCEDURE fga_session_killer (
  object_schema  VARCHAR2,
  object_name    VARCHAR2,
  policy_name    VARCHAR2)
AS
BEGIN
  dbms_scheduler.create_job
    (job_name      => dbms_scheduler.generate_job_name,
     job_type      => stored_procedure,
     job_action    => 'KILL_ME',
     start_date    => SYSDATE,
     enabled       => TRUE);
END;
/

BEGIN
  DBMS_FGA.drop_policy
                     (object_schema    => 'SCOTT',
                      object_name      => 'EMP',
                      policy_name      => 'FGA_FILTER');
  DBMS_FGA.add_policy
           (object_schema      => 'SCOTT',
            object_name        => 'EMP',
            policy_name        => 'FGA_FILTER',
            audit_condition    => 'ename != user',
            audit_column       => 'SAL',
            handler_schema     => 'SYS',
            handler_module     => 'FGA_SESSION_KILLER');
END;
/

CONN scott/tiger
SELECT ename, sal
  FROM scott.emp;
SELECT SYSDATE
  FROM DUAL;
CONN scott/tiger

CONN aud_mgr/am
EXEC show_aud

SPOOL off
CONN sys/oracle as sysdba
EXEC DBMS_FGA.DROP_POLICY( object_schema => 'SCOTT', object_name   => 'EMP', policy_name   => 'FGA_FILTER' );
DELETE FROM SYS.fga_log$;
COMMIT ;
ALTER USER scott ACCOUNT UNLOCK;
EDIT kill.log
