CREATE OR REPLACE PROCEDURE FGA_NOTIFY (
   object_schema   VARCHAR2,
   object_name     VARCHAR2,
   policy_name     VARCHAR2
)
AS
 l_message     varchar2(32767);
 l_mailhost    varchar2(30)     := 'rgmamersmtp.oraclecorp.com';
 l_mail_conn   utl_smtp.connection;
 l_from        varchar2(30)     := 'FGA_ADMIN@oracle.com';
 l_to          varchar2(30)     := 'david.knox@oracle.com';
BEGIN
   l_message := 'User ' ||
                USER ||
                ' successfully accessed ' ||
                object_schema ||
                '.' ||
                object_name ||
                ' on ' ||
                TO_CHAR (SYSDATE, 'Mon DD HH24:MI') ||
                ' with this statement:  "' ||
                SYS_CONTEXT ('userenv', 'current_sql') ||
                '"';
      l_mail_conn := utl_smtp.open_connection (l_mailhost, 25);
      utl_smtp.helo (l_mail_conn, l_mailhost);
      utl_smtp.mail (l_mail_conn, l_from);
      utl_smtp.rcpt (l_mail_conn, l_to);
      utl_smtp.data (
         l_mail_conn,
         'Subject: FGA Alert' ||
         utl_tcp.crlf ||
         'To: ' ||
         l_to ||
         utl_tcp.crlf ||
         l_message
      );
      utl_smtp.quit (l_mail_conn);
   EXCEPTION
      WHEN OTHERS
      THEN
         utl_smtp.quit (l_mail_conn);
         raise_application_error (
            -20000,
            'Failed due to the following error: ' || SQLERRM
         );
END;
/
sho errors
