conn scott/tiger
-- refresh data
DROP TABLE emp_copy;
CREATE TABLE emp_copy AS SELECT * FROM emp;
ALTER TABLE emp_copy ENABLE ROW MOVEMENT;
-- give everyone a 10% raise
UPDATE emp_copy
   SET sal = sal * 1.1;
COMMIT ;
-- show database keeps track of values
COL ename format a6
COL "Start" format a22
COL "End"   format a22
COL "XID" format a16
SELECT   ename,
         sal,
         versions_xid "XID",
         versions_starttime "Start",
         versions_endtime "End"
    FROM emp_copy
   VERSIONS BETWEEN TIMESTAMP MINVALUE AND MAXVALUE    
   WHERE deptno = 20
ORDER BY 1, 2;

COL table_owner format a11
COL table_name format a10
COL operation format a10
COL logon_user format a10
SELECT DISTINCT table_owner,
                table_name,
                operation,
                logon_user
           FROM flashback_transaction_query
          WHERE xid =
                     HEXTORAW ('0400150012010000')
            AND table_name IS NOT NULL;

SELECT undo_sql
  FROM flashback_transaction_query
 WHERE xid = HEXTORAW ('0400150012010000')
   AND table_name IS NOT NULL
   AND ROWNUM <= 1;

-- current data
SELECT ename, sal FROM scott.emp_copy
 WHERE deptno = 20;
-- recover data
DECLARE
  l_undo_sql  VARCHAR2 (32767);
BEGIN
  FOR rec IN
    (SELECT undo_sql
       FROM flashback_transaction_query
      WHERE xid = HEXTORAW ('0400150012010000')
        AND table_name IS NOT NULL)
  LOOP
    l_undo_sql := REPLACE (rec.undo_sql, ';', '');
    EXECUTE IMMEDIATE l_undo_sql;
  END LOOP;

  COMMIT;
END;
/

SELECT ename, sal FROM scott.emp_copy
 WHERE deptno = 20;

EXEC print_table ('select * from flashback_transaction_query where xid = hextoraw(''0400150012010000'')')
