-- sys_context('userenv','statementid') did not work

CREATE OR REPLACE VIEW env
AS
  SELECT SYS_CONTEXT ('userenv', 'session_user')
                                     session_user,
         SYS_CONTEXT ('userenv', 'current_user')
                                     CURRENT_USER,
         SYS_CONTEXT ('userenv', 'current_schema')
                                   current_schema,
         NVL (SYS_CONTEXT ('userenv',
                           'external_name'),
              'NULL') external_name,
         NVL (SYS_CONTEXT ('userenv',
                           'client_identifier'),
              'NULL') client_identifier,
         NVL (SYS_CONTEXT ('userenv',
                           'client_info'),
              'NULL') client_info,
         NVL (SYS_CONTEXT ('userenv',
                           'proxy_user'),
              'NULL') proxy_user,
         SYS_CONTEXT ('userenv',
                      'audited_cursorid')
                                 audited_cursorid,
         SYS_CONTEXT ('userenv', 'entryid')
                                          entryid,
         NVL (SYS_CONTEXT ('userenv', 'sessionid'),
              'NULL') sessionid,
         SYS_CONTEXT ('userenv', 'isdba') isdba,
         NVL (SYS_CONTEXT ('userenv',
                           'ip_address'),
              'NULL') ip_address,
         SYS_CONTEXT ('userenv', 'db_name')
                                          db_name,
         SYS_CONTEXT ('userenv', 'host') HOST,
         NVL (SYS_CONTEXT ('userenv',
                           'network_protocol'),
              'NULL') network_protocol,
         NVL (SYS_CONTEXT ('userenv',
                           'authentication_type'),
              'NULL') authentication_type,
         SYS_CONTEXT ('userenv', 'policy_invoker')
                                   policy_invoker,
         NVL (SYS_CONTEXT ('userenv',
                           'current_sql'),
              'NULL') current_sql
    FROM DUAL;

GRANT SELECT ON env TO PUBLIC;
CREATE PUBLIC SYNONYM env FOR env;
DESC env
COL session_user format a10
COL network_protocol format a10
COL authentication_type format a20
SELECT session_user, authentication_type, ip_address
  FROM env;



-- set identifier
EXEC DBMS_SESSION.SET_IDENTIFIER( 'SecurityClassAppDemo:' || USER );

/******** Package DBMS_APPLICATION_INFO *******
Application developers can use the DBMS_APPLICATION_INFO package with Oracle Trace and the 
SQL trace facility to record names of executing modules or transactions in the database for 
later use when tracking the performance of various modules and debugging.

Registering the application allows system administrators and performance tuning specialists 
to track performance by module. System administrators can also use this information to track 
resource use by module. When an application registers with the database, its name and actions 
are recorded in the V$SESSION and V$SQLAREA views.
************************************************/
-- set information to tell database what we are doing
EXEC DBMS_APPLICATION_INFO.SET_CLIENT_INFO (USER ||': running env.sql on ' || to_char(sysdate,'DD-MON-YYYY HH24:MI:SS'));
